PROGRAM Config;
  {  CONFIG.C written in C by Mike Klein, CompuServe ID 73237,2531 }
  {  version 1.6 published in LAN Technology magazine, 9/89 issue  }
  {  The author's address then was: 10951 Sorrento Valley Rd. #1F  }
  {                                 San Diego, CA 92121            }
  {  The published source code did not claim to be copyrighted,    }
  {  and could be downloaded from a bulletin board at 603/882-1599 }
  {  which no longer appears to be in operation.                   }
  {  To whatever extent I have the right to do so, I likewise      }
  {  leave this Pascal version free of copyright, asking only that }
  {  improved versions be likewise posted for the benefit of all.  }
  {  Compile with Turbo Pascal version 6 or later                  }
  {  Requires Novell API for Turbo Pascal 6 by Tony Covelli,       }
  {  available on CompuServe, in the NOVA forum as NWAPIT.ZIP      }
  {  His CompuServe ID is 100015,3611.                             }
  {  8/10/91 JFS v2.10 Altered to replace CONFIG.C                 }
  { 10/11/91 JFS v2.11 Replace OS_VER with Novell-style OS_VERSION }
  { 11/07/91 JFS v2.12 Limit PSTAT to 8 characters                 }
  {              This allows it to be used as a DOS filename       }
  { The only command line parameter is /E                          }
  { If present, several DOS environment variables are set          }

{$B-,D-,F-,I-,L+,N-,R-,S-,V-}
{$M 4096,0,0}

USES Dos, Crt, Graph, NWVAR, NWPROC, NWERROR, NWCONN;

CONST
  HexCh : array[0..15] of char = '0123456789ABCDEF'; {Used by Hex functions}
  NetError : word = 0;                               {Used by Netware APIs}

TYPE
  Byt4ArrayType = array [0 .. 3] of byte;
  Byt6ArrayType = array [0 .. 5] of byte;
  Byt8ArrayType = array [0 .. 7] of byte;
  Str1Type      = string [1];
  Str2Type      = string [2];
  Str3Type      = string [3];
  Str4Type      = string [4];
  Str5Type      = string [5];
  Str6Type      = string [6];
  Str8Type      = string [8];
  Str12Type     = string [12];

VAR
  {Variables used to find and change DOS environment}
  UseCurrentEnv,                { true if current environment is accessed }
  SecondCommand : boolean;      { true if secondary COMMAND.COM is loaded }
  EnvTyp        : byte;         { environment type }
  EnvAddr,                      { environment address }
  RootEnvAddr   : word;         { root environment address }
  EnvSize,                      { environment size }
  RootEnvSize,                  { root environment size }
  i             : integer;      { temporary loop index}
  Regs          : Registers;
  EnvStr,
  EnvVar        : string;
  {Variables used to find machine configuration}
  exp,                          { Expanded memory? (T/F)         }
  ext,                          { Extended memory? (T/F)         }
  fpu,                          { FPU present? (T/F)             }
  mouse         : Str1Type;     { Mouse present? (T/F)           }
  class         : Str2Type;     { Like model, but only (PC/AT)   }
  conv,                         { Conventional memory size       }
  cpu,                          { CPU type (808x, 80286, 80386)  }
  video         : Str4Type;     { Video adapter (MDA, HERC, CGA, }
                                {                EGA, PGA, VGA)  }
  os_version    : Str5Type;     { DOS version number             }
  mode,                         { Video mode (COLOR/MONO)        }
  free          : Str6Type;     { Free conventional memory       }
  netaddr       : Str8Type;     { LAN network address            }
  pstat         : Str12Type;    { LAN physical station number    }

  env_set       : boolean;      { flags whether to set EVARs     }
  Major,                        { major DOS version number       }
  Minor,                        { minor DOS version number       }
  byt           : byte;
  g_driver,                     { graphic driver type found      }
  g_mode        : integer;      { current mode of graphic driver }
  memval,
  CPUval,
  far_ptr       : word;
  have          : longint;

  { Variables used by Novell API Interface }
  NNString         : String8Type;
  NAString         : String12Type;
  Network          : Byte4ArrayType;
  NodeAddress      : Byte6ArrayType;
  StatNumber,
  Socket           : word;

FUNCTION Hex(i : integer): Str4Type;
      { convert an integer to hex string }

VAR
  Temp   : byte;
  TempSt : Str2Type;

begin
  Temp   := hi(i);
  TempSt := HexCh[Temp shr 4] + HexCh[Temp and $0F];
  Temp   := lo(i);
  Hex    := TempSt + HexCh[Temp shr 4] + HexCh[Temp and $0F];
end;  { Hex }

FUNCTION Hex4Byt(i : Byte4ArrayType): String8Type;
      { convert a 4 byte array of bytes to a hex string }

VAR
  Temp       : byte;
  Temp4Array : Byt4ArrayType;
  TempSt     : Str8Type;
  j          : integer;

begin {Hex4Byt}
  TempSt :='00000000';
  for j := 0 to 3 do
    begin {for}
      Temp := i[j];
      TempSt[2*j+1] := HexCh[Temp shr 4];
      TempSt[2*j+2] := HexCh[Temp and $0F];
    end; {for}
  Hex4Byt := TempSt;
end;  {Hex4Byt}


FUNCTION Hex6Byt(i : Byte6ArrayType): String12Type;
      { convert a 6 byte array of bytes to a hex string }

VAR
  Temp       : byte;
  Temp4Array : Byt6ArrayType;
  TempSt     : Str12Type;
  j          : integer;

begin {Hex6Byt}
  TempSt :='000000000000';
  for j := 0 to 5 do
    begin {for}
      Temp := i[j];
      TempSt[2*j+1] := HexCh[Temp shr 4];
      TempSt[2*j+2] := HexCh[Temp and $0F];
    end; {for}
  Hex6Byt := TempSt;
end;  {Hex6Byt}

PROCEDURE GetEnvTyp(VAR EnvTyp : byte);
      {Which type of DOS and environment type is on this PC?}

begin {GetEnvTyp}
  { assign environment type according to DOS version }
  Major := Lo(DosVersion);
  Minor := Hi(DosVersion);
  EnvTyp := 3;
  case Major of
    2 : EnvTyp := 1;
    3 : case Minor of
          0, 10 : EnvTyp := 1;
          20    : EnvTyp := 2
        end { case Minor }
  end { case Major }
end; { GetEnvTyp }

PROCEDURE SearchMemory(VAR RootEnvaddr : word; VAR RootEnvSize : integer);
      { search memory for root environment }

VAR
  ComMCB  : word;     { COMMAND.COM MCB }
  EnvMCB  : word;     { environment MCB }
  MCBsize : word;     { memory block size in paragraphs }
  Found   : boolean;  { root COMMAND.COM found }

  PROCEDURE CheckMCBchain(ComMCB : word; VAR EnvMCB : word;
                          VAR Found : boolean);
      { check for Memory Control Block chain }

  begin {CheckMCBchain}
    Found   := false;
    MCBsize := MemW[ComMCB : 3];
    EnvMCB  := Succ(ComMCB + MCBsize);
    if (Mem[EnvMCB : 0] = $4D) then
      Found := true;
  end; { CheckMCBchain }

begin { SearchMemory }

  { begin search for COMMAND.COM in low memory }
  ComMCB := $500;
  Found  := false;
  while not Found do
    begin {while}
      { MCB begins with $4D }
      if Mem[ComMCB:0] = $4D then
        begin {if}
          { check for matching PSP address }
          if MemW[ComMCB : 1] = Succ(ComMCB) then
            CheckMCBchain(ComMCB,EnvMCB,Found);
        end; {if}

      { if not Found then continue search at next paragraph boundary }
      Inc(ComMCB);
    end; { while }

  { check for environment type }
  if MemW[ComMCB : $2C] = 0 then
    { root environment of DOS 2.0 - 3.2 }
    begin {if}
      RootEnvAddr := Succ(EnvMCB);
      MCBsize := MemW[EnvMCB : 3];
      RootEnvSize := MCBsize * $10
    end {if}
  else
    { root environment of DOS 3.3 - 4.0 }
    begin {else}
      RootEnvAddr := MemW[ComMCB : $2C];
      EnvMCB := Pred(RootEnvaddr);
      MCBsize := MemW[EnvMCB : 3];
      RootEnvSize := MCBsize * $10
    end {else}
end;  { SearchMemory }

PROCEDURE GetEnv(VAR EnvAddr : word; VAR EnvSize : integer;
                 VAR RootEnvAddr : word; VAR RootEnvSize : integer;
                 EnvTyp : byte);
      {Get active environment}

VAR
  PSPaddr : word;  { COMMAND.COM PSP address }
  ComMCB  : word;  { COMMAND.COM MCB }
  EnvMCB  : word;  { environment MCB }
  MCBsize : word;  { memory block size in paragraphs }

begin {GetEnv}
  RootEnvAddr := 0;

  { COMMAND.COM PSP address at offset $16 in program PSP }
  PSPaddr := MemW[PrefixSeg : $16];

  { check for child process }
  while (PSPaddr <> MemW[PSPaddr : $16]) do
    PSPaddr := MemW[PSPaddr : $16];

  { COMMAND.COM MCB address }
  ComMCB := Pred(PSPaddr);

  { size of COMMAND.COM }
  MCBsize := MemW[ComMCB : 3];

  { environment MCB address }
  EnvMCB := PSPaddr + MCBsize;

  { assign environment address }
  EnvAddr := Succ(EnvMCB);

  { size of environment }
  MCBsize := MemW[EnvMCB : 3];
  EnvSize := MCBsize * $10;

  { check for secondary COMMAND.COM }
  case EnvTyp of
    { $2C points to DOS environment in DOS 2.0 - 3.1 }
    1 : if (MemW[PSPaddr : $2C] <> 0) then
          begin {case 1}
            SearchMemory(RootEnvAddr,RootEnvSize);
            { re-assign environment address }
            EnvAddr := MemW[PSPaddr : $2C];
            EnvMCB := Pred(Envaddr);
            MCBsize := MemW[EnvMCB : 3];
            EnvSize := MCBsize * $10
          end; {case 1}
        { $2C points to program environment in DOS 3.2 }
    2 : if (MemW[PSPaddr : $2C] <> 0) then
          SearchMemory(RootEnvAddr,RootEnvSize);
        { $2C points to DOS environment in DOS 3.3 - 4.0 }
    3 : if (MemW[PSPaddr : $2C] = EnvAddr) then
          SearchMemory(RootEnvAddr,RootEnvSize)
        else
        { re-assign environment address }
          begin {case 3 else}
            EnvAddr := MemW[PSPaddr : $2C];
            EnvMCB := Pred(Envaddr);
            MCBsize := MemW[EnvMCB : 3];
            EnvSize := MCBsize * $10
          end {case 3 else}
  end { case }
end;  { GetEnv }

FUNCTION UpStr(St : string) : string;
{ convert a string to upper case }

VAR
  i : byte;

begin {UpStr}
  for i := 1 to Length(St) do
    St[i] := UpCase(St[i]);
  UpStr := St
end;  {UpStr}

FUNCTION TrimLeft(St :string) : string;
{ Delete leading zeroes from numeric string }

VAR
  i,
  j : Integer;

begin {TrimLeft}
  i := 1;
  j := Length(St) + 1;
  while (St[i] = '0') do
    Inc(i);
  TrimLeft := Copy(St, i, j - i);
end; {trimLeft}


FUNCTION Position(St : string; EnvAddr : word; ArrayLen : integer) : integer;
      {find the position of a string in the environment array}

VAR
  Found : boolean;
  Match : boolean;
  StLen : integer;
  i     : integer;
  p     : integer;

begin {Position}
  Found := false;
  StLen := Length(St);
  p     := 0;
  while (not Found) and ((ArrayLen - p+1) >= StLen) do
    { find first match }
    begin {while}
      if St[1] = Chr(Mem[EnvAddr : p]) then
        { find next match }
        begin {if}
          Match := true;
          i := 1;
          while Match and (i < StLen) do
            if St[1+i] = Chr(Mem[EnvAddr : p+i]) then
              Inc(i)
            else
              Match := false;
          Found := Match
        end; {if}
      if not Found then
        Inc(p)
    end; {while}
  if found then
    Position := p
  else
    Position := -1
end; {Position}

PROCEDURE WriteEnvVar(EnvParam, EnvVar : string);
       {Write an environment variable}

VAR
  ArrayLen : integer;  { environment array length }
  EnvStr   : string;   { environment string }
  StLen    : integer;  { environment string length }
  ParamPos : integer;  { parameter position }
  i        : integer;

begin {WriteEnvVar}
  if EnvParam = '' then
    Exit;
  if not UseCurrentEnv then
    begin {if}
      EnvAddr := RootEnvAddr;
      EnvSize := RootEnvSize;
    end; {if}

  { check if environment is empty }
  if Mem[EnvAddr : 0] = 0 then
    ArrayLen := 0
   else
     begin {else}
       { get the length of the environment string }
       ArrayLen := Position(#0#0,EnvAddr,EnvSize);
       if ArrayLen = -1 then
         begin {if}
           Writeln('End of environment not found');
           Halt
         end {if}
     end; {else}

  { initialize variables }
  EnvParam := UpStr(EnvParam) + '=';
  EnvStr := EnvParam + EnvVar + #0#0;
  StLen := Length(EnvStr);

  { search for variable in environment }
  ParamPos := Position(EnvParam,EnvAddr,ArrayLen);

  if ParamPos = -1 then
    begin {if}
      { check for empty variable }
      if EnvVar = '' then
        Exit;

      { environment parameter not found }
      { compare environment with string }
      if (ArrayLen + StLen + 1) > EnvSize then
        Writeln('Environment full')
      else
        { add new variable string to end of array }
        begin {else}
          if ArrayLen = 0 then
            Move(EnvStr[1], Mem[EnvAddr : 0], StLen)
          else
            Move(EnvStr[1], Mem[EnvAddr : ArrayLen+1], StLen)
          end {else}
    end {if}
    { environment parameter found }
    { get length of variable string }
  else
    begin {else}
      { skip three characters in array }
      i := ParamPos + 3;
      while Mem[EnvAddr : i] <> 0 do
        Inc(i);

      { get beginning of next variable string }
      Inc(i);

      { delete variable from current position in array }
      Move(Mem[EnvAddr: i], Mem[EnvAddr: ParamPos], (ArrayLen+2)-i);
      ArrayLen := ArrayLen - (i-ParamPos);

      { check for empty variable }
      if EnvVar = '' then
        Exit;

      { compare environment array length with environment size }
      if (ArrayLen + StLen + 1) > EnvSize then
        Writeln('Environment full')
      else
        { add variable to end of array }
        Move(EnvStr[1], Mem[EnvAddr : ArrayLen+1], StLen)
    end {else}
end; {WriteEnvVar}

Function CPUis:word;
Begin {CPUis}
  inline (
  $9C/          {pushf           }
  $31/$C0/      {xor  ax,ax      }
  $50/          {push  ax        }
  $9D/          {popf            }
  $9C/          {pushf           }
  $58/          {pop  ax         }
  $25/$00/$F0/  {and  ax,0f000h  }
  $3D/$00/$F0/  {cmp  ax,0f000h  }
  $74/$16/      {jz    is_808x   }

  {If we can't set bits 12-14, CPU is a 286}
  $B8/$00/$70/  { mov  ax,07000h }
  $50/          { push  ax       }
  $9D/          { popf           }
  $9C/          { pushf          }
  $58/          { pop  ax        }
  $25/$00/$70/  { and  ax,07000h }
  $74/$05/      { jz    is_80286 }

  {is_80386}
  $B8/$86/$03/  { mov  ax,386h   }
  $EB/$08/      { jmp  done      }
  {is_80286}
  $B8/$86/$02/  { mov  ax,286h   }
  $EB/$03/      { jmp  done      }
  {is_808x}
  $B8/$86/$00/  { mov  ax,86h    }
  {done}
  $9D/          { popf           }
  $89/$46/$FE); { mov  [bp-2],ax }
End; {CPUis}

begin {Config}
  env_set := false;
  if ParamCount > 0 then
    if ((ParamStr(1) = '/E') or (ParamStr(1) = '/e')) then
      env_set := true
    else
      begin {else}
        Writeln;
        Writeln('ERROR: Bad parameter...');
        Halt
      end; {else}

  { initialize environment address }
  UseCurrentEnv := true;
  SecondCommand := true;
  GetEnvTyp(EnvTyp);
  GetEnv(EnvAddr,EnvSize,RootEnvAddr,RootEnvSize,EnvTyp);
  if RootEnvAddr = 0 then
    begin {if}
      RootEnvAddr := EnvAddr;
      RootEnvSize := EnvSize;
      SecondCommand := false
    end; {if}

  if (env_set = false) then
    begin {if}
      Writeln;
      Writeln;
      Writeln('SYSTEM CONFIGURATION v2.12');
      Writeln('==========================')
    end; {if}

  {**************}
  {* OS VERSION *}
  {**************}

  os_version := 'V' + Chr(Major + $30) + '.'
                    + Chr((Minor DIV $0A) + $30)
                    + Chr((Minor MOD $0A) + $30);

  if (env_set) then
    WriteEnvVar('OS_VERSION', os_version)
  else
    Writeln('OS_VERSION..', os_version);

  {************}
  {* CPU TYPE *}
  {************}

  CPUval := CPUis;

  case (CPUval) of
      $386 :
        begin {case 386}
          cpu   := '386';
          class := 'AT'
        end; {case 386}
      $286 :
        begin {case 286}
          cpu   := '286';
          class := 'AT';
        end; {case 286}
      $86 :
        begin {case 86}
          cpu   := '808x';
          class := 'PC'
        end {case 86}
      else
        begin {case else}
          cpu   := 'N/A';
          class := 'N/A'
        end {case else}
    end; {case}

  if (env_set) then
    begin {if}
      WriteEnvVar('CPU', cpu);
      WriteEnvVar('CLASS', class)
    end {if}
  else
    begin {else}
      Writeln('CPU.........', cpu);
      Writeln('CLASS.......', class)
    end; {else}

   {**************}
   {* MATH CHIP? *}
   {**************}

  Intr($11,regs); { Get BIOS equip word for FPU }

  if ((Regs.AX AND $02) <> $00) then
    fpu := 'T'
  else
    fpu := 'F';

  if (env_set) then
    WriteEnvVar('FPU', fpu)
  else
    Writeln('FPU.........', fpu);

  {***********************}
  {* CONVENTIONAL MEMORY *}
  {***********************}

  Intr($12, regs);              { INT 0x12 returns conv memory  }
  memval := Regs.AX;
  if ((memval MOD 2) <> 0) then { Some systems report 1K less   }
    Inc(memval);                { than actual, so we compensate }
  Str((memval AND $F000)
    + (memval AND $0F00)
    + (memval AND $00F0)
    + (memval AND $000F), conv);
  if (env_set) then
    WriteEnvVar('CONV', conv)
  else
    Writeln('CONV........', conv);

  {********************}
  {* FREE CONV MEMORY *}
  {********************}

  Regs.AH := $48;
  Regs.BX := $FFFF;
  MSDOS(Regs);
  memval := Regs.BX;

  {Convert result from binary bytes to decimal K bytes}
  have := ((4096 * ((memval SHR 12) AND $000F))
       +   ( 256 * ((memval SHR  8) AND $000F))
       +   (  16 * ((memval SHR  4) AND $000F))
       +   (       ( memval         AND $000F))) DIV 64 + 33;
  {We add 33 because Config uses 33K of RAM itself}
  {Result is conservative - there may be 1-4K more RAM free than claimed}

  Str(have, free);
  if (env_set) then
    WriteEnvVar('FREE', free)
  else
    Writeln('FREE........', free);

  {*******************}
  {* EXPANDED MEMORY *}
  {*******************}

  Regs.AX := $3567;
  MSDOS(Regs);
  far_ptr := Regs.ES;

  exp := 'T';  
  {Look for EMMXXXX0 ID string}
  if Mem[far_ptr : 10] <> $45 then exp := 'F';
  if Mem[far_ptr : 11] <> $4D then exp := 'F';
  if Mem[far_ptr : 12] <> $4D then exp := 'F';
  if Mem[far_ptr : 13] <> $58 then exp := 'F';
  if Mem[far_ptr : 14] <> $58 then exp := 'F';
  if Mem[far_ptr : 15] <> $58 then exp := 'F';
  if Mem[far_ptr : 16] <> $58 then exp := 'F';
  if Mem[far_ptr : 17] <> $30 then exp := 'F';

  if (env_set) then
    WriteEnvVar('EXP', exp)
  else
    Writeln('EXP.........', exp);

  {*******************}
  {* EXTENDED MEMORY *}
  {*******************}

  { This code must follow the CPU code  }
  ext := 'F';
  if (class = 'AT') then
    begin {if}
      Regs.AX := $8800;
      Intr($15, Regs);
      memval := Regs.AX;
      if ((memval <> $8800) AND (memval <> $0000)) then
        ext := 'T'
    end; {if}

  if (env_set) then
    WriteEnvVar('EXT', ext)
  else
    Writeln('EXT.........', ext);

   {**********}
   {* MOUSE? *}
   {**********}

  Regs.AX := $00;  { Mouse Func 0 - initialize }
  Intr($33, Regs);
  if (Regs.AX <> $0000) then
    mouse := 'T'
  else
    mouse := 'F';

  if (env_set) then
    WriteEnvVar('MOUSE', mouse)
  else
    Writeln('MOUSE.......', mouse);

  {**************}
  {* VIDEO MODE *}
  {**************}

  Regs.AX := $0F00;
  Intr($10, Regs); {Video interrupt}
  case (Regs.AL) of
     $00,
     $02,
     $07  : mode := 'MONO'
  else
    mode  := 'COLOR'
  end; {case}

  if (env_set) then
    WriteEnvVar('MODE', mode)
  else
    Writeln('MODE........', mode);

   {*****************}
   {* VIDEO ADAPTER *}
   {*****************}

  DetectGraph(g_driver, g_mode);

  case (g_driver) of
    1,
    2  : video := 'CGA';
    3,
    4,
    5  : video := 'EGA';
    6  : video := 'PGA';
    7  : video := 'HERC';
    9  : video := 'VGA'
  else
    video := 'MDA'
  end; {case}
  if video = 'MDA' then
    begin {if}
      {Read CRT status port, mask bit 7}
      video := 'MDA';
      byt   := (Port[$03BA] AND $80);
      for i:= 0 to 32767 do
        { If bit 7 changes, it's HERC }
        if (byt <> (Port[$03BA] AND $80)) then
          video := 'HERC'
    end; {if}

  if (env_set) then
    WriteEnvVar('VIDEO', video)
  else
    Writeln('VIDEO.......', video);

   {***************}
   {* LAN ADDRESS *}
   {***************}

  pstat   := 'N/A';
  netaddr := 'N/A';
  Regs.AH := $DB;
  MSDOS(Regs);
  if (Regs.AL <> 0) then
    {IPX is loaded} 
    begin {if}
      StatNumber := GetConnectionNumber;
      NetError := GetInternetAddress(StatNumber,
                                     Network,
                                     NodeAddress,
                                     Socket      );
      if NetError = Successful then
        begin {if}
          ConvertNetworkNumber(Network, NNString);
          ConvertNodeAddress(NodeAddress, NAString);
          pstat := TrimLeft(UpStr(NAString));
          {Limit result to 8 least-significant digits, for DOS filenames}
          if Length(pstat) > 8 then pstat := Copy(pstat, 5, 8);
          netaddr := TrimLeft(UpStr(NNString));
        end {if}
    end; {if}

  if (env_set) then
    begin {if}
      WriteEnvVar('PSTAT', pstat);
      WriteEnvVar('NETADDR', netaddr)
    end {if}
  else
    begin {else}
      Writeln('PSTAT.......', pstat);
      Writeln('NETADDR.....', netaddr)
    end; {else}

end. {Config}